#!/bin/sh

# test-cpp.sh
# VTable Tests
# Created by Michel Fortin on 2009-02-15.

if [ -d "/System/Library/Frameworks/Foundation.framework" ]
then
	# This is Mac OS X: enable Objective-C testing
	MAIN="main.mm testobjc.m"
	EXTRA_FLAGS="-framework Foundation"
else
	# Not Mac OS X: disable Objective-C
	MAIN="main.cpp"
	EXTRA_FLAGS=
fi

echo Compiling...

g++ \
	$MAIN \
	teststatic.cpp \
	teststatic2.cpp \
	testcpp.cpp \
	teststandard.cpp \
	testdynamic.cpp \
	testdynamicindirect.cpp \
	clock.c \
	-o ./vtable-runtests \
	$EXTRA_FLAGS \
	$*

if [ $? -eq 0 ]
then
	./vtable-runtests
fi

exit $?
