#include "testdynamicindirect.h"
#include "clock.h"
#include <cstdio>

namespace TestDynamicIndirect
{
	struct VTable;
	struct VTableIndirect;

	struct TestObject
	{
		VTableIndirect * vtableindirect;
	};

	struct VTableIndirect
	{
		VTable* vtable;
	};

	struct VTable
	{
		void (*vcall[2])(TestObject *);
	};

	__attribute__ ((noinline)) 
	static void vcallImplementation(TestObject * object)
	{
		
	}

	static unsigned int callOffset;

	static TestObject * create()
	{
		TestObject * object = new TestObject;
		object->vtableindirect = new VTableIndirect;
		object->vtableindirect->vtable = new VTable;
		object->vtableindirect->vtable->vcall[1] = &vcallImplementation;
		callOffset = 1;
		return object;
	}
}

unsigned int testDynamicIndirect(unsigned testCount)
{
	using namespace TestDynamicIndirect;
	
	TestObject* object = create();
	startClock();
	for (unsigned i = 0; i < testCount; ++i)
		object->vtableindirect->vtable->vcall[callOffset](object);
	return currentClock();
}
